{ Snake Pit 2.1 Copyright by Jeff Weston }

{$G+}

uses
  Crt, Graph, dos, effects;

type dirs = (none, up, down, left, right);
     status = (unknown,found_num,boxed_in);
     food_data_array = array[1..12288] of byte;
     food_data_ptr = ^food_data_array;
     player_data = record
       computer_player,alive,waiting,dying,trail : boolean;
       cur_x, cur_y, tail_x, tail_y, lives, length, buf_size,
       to_go, death_delay,temp_x,ttempx,ttempy,temp_y,food_x,food_y,
       poopies,comp_temp1,comp_temp2,comp_temp3 : integer;
       score : longint;
       comp_status : status;
       move_buffer : array[1..10] of dirs;
       cur_dir,temp_dir : dirs;
       keys : array[1..4] of char;
       key_sp : array[1..4] of boolean;
     end;
     demo_mode = (normal, record_demo, play);

var
  food_data_x,food_data_y : food_data_ptr;
  GraphDriver, GraphMode,players,d_length,life_num,max_nums,total_nums,
  total_food,beep_stop,level,t_level : integer;
  blahs : longint;
  FontF: file;
  FontP: pointer;
  screen : array [1..128, 1..96] of char;
  screen_dis : array [1..128, 1..96] of integer;
  player : array [1..12] of player_data;
  nums_to_go : array [1..9] of integer;
  last_dir : dirs;
  sound_on,level_change : boolean;
  demo : demo_mode;
  demo_file : file of integer;

  { Notes for Screen:

    Empty         : ' '
    Full          : '+'
    Full (orig)   : '-'
    Dead          : '='

    numbers       : '1-9'
    Number Markers: <Shift> '1-9'
    Number Marker : '~'

    Up            : 'A'
    Down          : 'B'
    Left          : 'C'
    Right         : 'D'

    Temp Up       : 'E'
    Temp Down     : 'F'
    Temp Left     : 'G'
    Temp Right    : 'H' }

function random2 (num : integer) : integer;
var temp : integer;
begin
  if demo = play then read(demo_file,temp)
  else begin
    temp := random(num);
    if demo = record_demo then write(demo_file,temp);
  end;
  random2 := temp;
end;

function check_keys(key : char; special : boolean) : boolean;
var temp1, temp2 : integer;
begin
  check_keys := true;
  for temp1 := 1 to 12 do for temp2 := 1 to 4 do
    if (player[temp1].key_sp[temp2] = special) and
       (player[temp1].keys[temp2] = key) then check_keys := false;
end;


function yn : boolean;
var input :char;
begin
  repeat
    input := upcase(readkey);
  until (input = 'Y') or (input = 'N');
  if input = 'N' then yn := false
  else yn := true;
end;

procedure add(num : integer; k_dir : dirs);
begin
  if player[num].buf_size = 0 then begin
    player[num].buf_size := 1;
    player[num].move_buffer[1] := k_dir;
  end
  else if (player[num].buf_size < 9) and
          (player[num].move_buffer[player[num].buf_size] <> k_dir) then begin
    inc(player[num].buf_size);
    player[num].move_buffer[player[num].buf_size] := k_dir;
  end;
end;

procedure check_esc(var game_over : boolean);
var input : char;
begin
  while keypressed do
  begin
    input := readkey;
    if ord(input) = 27 then game_over := true;
    if ord(input) = 0 then input := readkey;
  end;
end;

procedure get_keys(var game_over : boolean);
var temp1, temp2 : integer;
    input : char;
begin
  while keypressed do
  begin
    input := upcase(readkey);
    case ord(input) of
      27 : game_over := true;
      0  : begin
        input := readkey;
        for temp1 := 1 to players do for temp2 := 1 to 4 do
        begin
          if (player[temp1].key_sp[temp2]) and
             (player[temp1].keys[temp2] = input) then
          case temp2 of
            1 : add(temp1,up);
            2 : add(temp1,down);
            3 : add(temp1,left);
            4 : add(temp1,right);
          end;
        end;
      end;
    else
      for temp1 := 1 to players do for temp2 := 1 to 4 do
      begin
        if (not(player[temp1].key_sp[temp2])) and
           (player[temp1].keys[temp2] = input) then
        case temp2 of
          1 : add(temp1,up);
          2 : add(temp1,down);
          3 : add(temp1,left);
          4 : add(temp1,right);
        end;
      end;
    end;
  end;
end;

function good_move(num : integer; move : dirs) : boolean;
begin
  good_move := true;
  if (move = up) and (player[num].cur_dir = down) then good_move := false;
  if (move = down) and (player[num].cur_dir = up) then good_move := false;
  if (move = left) and (player[num].cur_dir = right) then good_move := false;
  if (move = right) and (player[num].cur_dir = left) then good_move := false;
end;

procedure human_move(num : integer);
var temp1,temp : integer;
    t_move : dirs;
begin
  t_move := player[num].cur_dir;
  if player[num].buf_size = 1 then begin
    t_move := player[num].move_buffer[1];
    player[num].move_buffer[1] := none;
    player[num].buf_size := 0;
  end;
  if (player[num].buf_size > 1) then begin
    t_move := player[num].move_buffer[1];
    for temp1 := 1 to player[num].buf_size do
      player[num].move_buffer[temp1] := player[num].move_buffer[temp1+1];
    dec(player[num].buf_size);
  end;
  if good_move(num,t_move) then player[num].cur_dir := t_move;
end;

procedure set_up_screen;
var temp1,temp2:integer;
begin
  for temp1 := 1 to 96 do for temp2 := 1 to 128 do
  begin
    screen[temp2,temp1] := ' ';
  end;
  for temp1 := 1 to 128 do
  begin
    screen[temp1,1] := '-';
    screen[temp1,96] := '-';
  end;
  for temp1 := 1 to 96 do
  begin
    screen[1,temp1] := '-';
    screen[128,temp1] := '-';
  end;
end;

procedure do_square(sq_x,sq_y,color,fill:integer);
begin
  if color = black then setfillstyle(solidfill,black)
  else setfillstyle(fill,color);
  bar((sq_x-1)*5,(sq_y-1)*5,sq_x*5-1,sq_y*5-1);
  setfillstyle(solidfill,black);
  bar((sq_x-1)*5+1,(sq_y-1)*5+1,sq_x*5-1-1,sq_y*5-1-1);
  if color <> black then begin
    setfillstyle(solidfill,white);
    bar((sq_x-1)*5+2,(sq_y-1)*5+2,sq_x*5-1-2,sq_y*5-1-2);
  end;
end;

procedure do_square2(sq_x,sq_y,color,fill:integer);
begin
  if color = black then setfillstyle(solidfill,black)
  else setfillstyle(fill,color);
  bar((sq_x-1)*5,(sq_y-1)*5,sq_x*5-1,sq_y*5-1);
end;

procedure draw_screen(b_color:integer);
var temp1, temp2 : integer;
begin
  for temp1 := 1 to 96 do for temp2 := 1 to 128 do
  if screen[temp2,temp1] <> ' ' then do_square2(temp2,temp1,b_color,solidfill);
end;

procedure clear_food_data;
var temp1 : integer;
begin
  total_food := 0;
  for temp1 := 1 to 12288 do begin
    food_data_x^[temp1] := 0;
  end;
end;

procedure add_food(fd_x,fd_y:integer);
var temp1 : integer;
    done : boolean;
begin
  temp1 := 0;
  done := false;
  repeat
    inc(temp1);
    if temp1 = 12289 then begin
      closegraph;
      writeln('Fatal Error: Ran out of room in food data array.');
      halt;
      dispose(food_data_x);
      dispose(food_data_y);
    end;
    if food_data_x^[temp1] = 0 then begin
      food_data_x^[temp1] := fd_x;
      food_data_y^[temp1] := fd_y;
      if temp1>total_food then total_food := temp1;
      done := true;
    end;
  until done;
end;

procedure del_food(fd_x,fd_y:integer);
var temp1,temp2 : integer;
    done,end_it : boolean;
begin
  temp1 := 0;
  done := false;
  repeat
    inc(temp1);
    if temp1 = 12289 then begin
      closegraph;
      writeln('Fatal Error: Food location not found in data array.');
      halt;
      dispose(food_data_x);
      dispose(food_data_y);
    end;
    if ((food_data_x^[temp1] = fd_x) and
        (food_data_y^[temp1] = fd_y)) then begin
      for temp2 := 1 to players do
        if ((food_data_x^[temp1] = player[temp2].food_x) and
            (food_data_y^[temp1] = player[temp2].food_y)) then
          player[temp2].food_x := 0;
      food_data_x^[temp1] := 0;
      if temp1=total_food then begin
        end_it := false;
        repeat
          dec(temp1);
          if temp1 = 0 then begin
            temp1 := 1;
            end_it := true;
          end;
        until (food_data_x^[temp1]<>0) or (end_it);
        total_food := temp1;
      end;
    done:=true;
    end;
  until done;
end;

function sides(x,y : integer) : boolean;
begin
  sides := true;
  if screen[x+1,y] = '+' then sides := false;
  if screen[x-1,y] = '+' then sides := false;
  if screen[x,y+1] = '+' then sides := false;
  if screen[x,y-1] = '+' then sides := false;
  if screen[x+1,y] = '-' then sides := false;
  if screen[x-1,y] = '-' then sides := false;
  if screen[x,y+1] = '-' then sides := false;
  if screen[x,y-1] = '-' then sides := false;
end;

procedure find_closest_food(num:integer);
var temp1,temp2 : integer;
begin
  for temp1 := 1 to total_food do begin
    if food_data_x^[temp1] <> 0 then

      if ((abs(food_data_x^[temp1]-player[num].cur_x) +
           abs(food_data_y^[temp1]-player[num].cur_y) <
           abs(player[num].food_x-player[num].cur_x) +
           abs(player[num].food_y-player[num].cur_y)) or
          (player[num].food_x=0)) then begin
{
      if (food_data_x^[temp1] < player[num].food_x) or
         (player[num].food_x=0) then begin
}
        if sides(food_data_x^[temp1],food_data_y^[temp1]) then begin
          player[num].food_x:=food_data_x^[temp1];
          player[num].food_y:=food_data_y^[temp1];
        end;
      end;
  end;
end;

procedure draw_number(sq_x,sq_y,number:integer);
var temp1,temp2 : integer;
begin
  for temp1 := sq_x to sq_x+3 do for temp2 := sq_y to sq_y+3 do
  begin
    if screen[temp1,temp2] = '=' then {del_food(temp1,temp2)};
    case number of
      1 : screen[temp1,temp2] := '1';
      2 : screen[temp1,temp2] := '2';
      3 : screen[temp1,temp2] := '3';
      4 : screen[temp1,temp2] := '4';
      5 : screen[temp1,temp2] := '5';
      6 : screen[temp1,temp2] := '6';
      7 : screen[temp1,temp2] := '7';
      8 : screen[temp1,temp2] := '8';
      9 : screen[temp1,temp2] := '9';
    end;
    do_square2(temp1,temp2,darkgray,interleavefill);
  end;
  setcolor(red);
  SetTextStyle(sansserifFont, HorizDir,1);
  for temp1 := sq_x to sq_x + 3 do
    case number of
      1 : screen[temp1,sq_y] := '!';
      2 : screen[temp1,sq_y] := '@';
      3 : screen[temp1,sq_y] := '#';
      4 : screen[temp1,sq_y] := '$';
      5 : screen[temp1,sq_y] := '%';
      6 : screen[temp1,sq_y] := '^';
      7 : screen[temp1,sq_y] := '&';
      8 : screen[temp1,sq_y] := '*';
      9 : screen[temp1,sq_y] := '(';
    end;
  for temp1 := sq_y to sq_y + 3 do
    case number of
      1 : screen[sq_x,temp1] := '!';
      2 : screen[sq_x,temp1] := '@';
      3 : screen[sq_x,temp1] := '#';
      4 : screen[sq_x,temp1] := '$';
      5 : screen[sq_x,temp1] := '%';
      6 : screen[sq_x,temp1] := '^';
      7 : screen[sq_x,temp1] := '&';
      8 : screen[sq_x,temp1] := '*';
      9 : screen[sq_x,temp1] := '(';
    end;
  case number of
    1 : outtextxy(sq_x*5+1,sq_y*5-8,'1');
    2 : outtextxy(sq_x*5+1,sq_y*5-8,'2');
    3 : outtextxy(sq_x*5+1,sq_y*5-8,'3');
    4 : outtextxy(sq_x*5+1,sq_y*5-8,'4');
    5 : outtextxy(sq_x*5+1,sq_y*5-8,'5');
    6 : outtextxy(sq_x*5+1,sq_y*5-8,'6');
    7 : outtextxy(sq_x*5+1,sq_y*5-8,'7');
    8 : outtextxy(sq_x*5+1,sq_y*5-8,'8');
    9 : outtextxy(sq_x*5+1,sq_y*5-8,'9');
  end;
  screen[sq_x, sq_y] := '~';
  for temp1 := sq_x to sq_x+3 do begin
    add_food(temp1,sq_y);
    add_food(temp1,sq_y+3);
  end;
  for temp1 := sq_y+1 to sq_y+2 do begin
    add_food(sq_x,temp1);
    add_food(sq_x+3,temp1);
  end;
end;

procedure put_player(pl_x,pl_y,num,fill : integer);
var color : integer;
begin
  case num of
    1 : color := red;
    2 : color := blue;
    3 : color := green;
    4 : color := cyan;
    5 : color := magenta;
    6 : color := brown;
    7 : color := lightgray;
    8 : color := yellow;
    9 : color := lightblue;
    10 : color := lightgreen;
    11 : color := lightcyan;
    12 : color := lightred;
  end;
  do_square(pl_x,pl_y,color,fill);
end;

function good_spot(x,y : integer) : boolean;
begin
  good_spot := true;
  if (x = 2) and
     (y = 48) then good_spot := false;
  if (x = 127) and
     (y = 48) then good_spot := false;
  if (x = 64) and
     (y = 2) then good_spot := false;
  if (x = 64) and
     (y = 95) then good_spot := false;
  if (x = 2) and
     (y = 3) then good_spot := false;
  if (x = 127) and
     (y = 3) then good_spot := false;
  if (x = 2) and
     (y = 94) then good_spot := false;
  if (x = 127) and
     (y = 94) then good_spot := false;
  if (x = 3) and
     (y = 2) then good_spot := false;
  if (x = 127) and
     (y = 2) then good_spot := false;
  if (x = 3) and
     (y = 95) then good_spot := false;
  if (x = 126) and
     (y = 95) then good_spot := false;
  if (x = 2) or
     (x = 127) or
     (y = 2) or
     (y = 95) then good_spot := false;
end;

procedure set_up_player(num : integer);
var temp1 : integer;
begin
  case num of
    1 : begin
      player[num].cur_dir := right;
      player[num].ttempx := 2;
      player[num].ttempy := 48;
      player[num].tail_x := 2;
      player[num].tail_y := 48;
    end;
    2 : begin
      player[num].cur_dir := left;
      player[num].ttempx := 127;
      player[num].ttempy := 48;
      player[num].tail_x := 127;
      player[num].tail_y := 48;
    end;
    3 : begin
      player[num].cur_dir := down;
      player[num].ttempx := 64;
      player[num].ttempy := 2;
      player[num].tail_x := 64;
      player[num].tail_y := 2;
    end;
    4 : begin
      player[num].cur_dir := up;
      player[num].ttempx := 64;
      player[num].ttempy := 95;
      player[num].tail_x := 64;
      player[num].tail_y := 95;
    end;
    5 : begin
      player[num].cur_dir := down;
      player[num].ttempx := 2;
      player[num].ttempy := 3;
      player[num].tail_x := 2;
      player[num].tail_y := 3;
    end;
    6 : begin
      player[num].cur_dir := down;
      player[num].ttempx := 127;
      player[num].ttempy := 3;
      player[num].tail_x := 127;
      player[num].tail_y := 3;
    end;
    7 : begin
      player[num].cur_dir := up;
      player[num].ttempx := 2;
      player[num].ttempy := 94;
      player[num].tail_x := 2;
      player[num].tail_y := 94;
    end;
    8 : begin
      player[num].cur_dir := up;
      player[num].ttempx := 127;
      player[num].ttempy := 94;
      player[num].tail_x := 127;
      player[num].tail_y := 94;
    end;
    9 : begin
      player[num].cur_dir := right;
      player[num].ttempx := 3;
      player[num].ttempy := 2;
      player[num].tail_x := 3;
      player[num].tail_y := 2;
    end;
    10 : begin
      player[num].cur_dir := left;
      player[num].ttempx := 126;
      player[num].ttempy := 2;
      player[num].tail_x := 126;
      player[num].tail_y := 2;
    end;
    11 : begin
      player[num].cur_dir := right;
      player[num].ttempx := 3;
      player[num].ttempy := 95;
      player[num].tail_x := 3;
      player[num].tail_y := 95;
    end;
    12 : begin
      player[num].cur_dir := left;
      player[num].ttempx := 126;
      player[num].ttempy := 95;
      player[num].tail_x := 126;
      player[num].tail_y := 95;
    end;
  end;
  player[num].to_go := 10;
  player[num].poopies := 0;
  player[num].death_delay := 0;
    for temp1 := 1 to 10 do player[num].move_buffer[temp1] := none;
  player[num].length := 0;
  player[num].buf_size := 0;
  player[num].food_x := 0;
  player[num].trail := false;
end;

procedure load_level(num : integer);
var levels : text;
    counter,var_code,x,y : integer;
    input1,input2 : string;
begin
  assign(levels,'levels.dat');
  reset(levels);
  counter := 1;
  while counter <> num do begin
    readln(levels,input1);
    if input1 = 'end' then inc(counter);
  end;
  repeat
    readln(levels,input1);
    if input1 <> 'end' then begin
      readln(levels,input2);
      val(input1,x,var_code);
      val(input2,y,var_code);
      screen[x,y] := '+';
    end;
  until input1 = 'end';
  close(levels);
end;

procedure get_level(num : integer);
var levels : text;
    counter : integer;
    input : string;
begin
  assign(levels,'levels.dat');
  reset(levels);
  counter:=0;
  repeat
    readln(levels,input);
    if input = 'end' then inc(counter);
  until input = 'eof';
  close(levels);
  if num>counter then t_level := random2(counter)+1;
  load_level(t_level);
end;

procedure put_space(x,y,color : integer);
begin
  if screen[x,y] = '+' then do_square2(x,y,color,solidfill)
  else do_square2(x,y,black,solidfill);
end;

procedure reverse(x,y,color : integer);
begin
  if screen[x,y] = '+' then begin
    screen[x,y] := ' ';
    do_square2(x,y,black,solidfill);
  end
  else begin
    screen[x,y] := '+';
    do_square2(x,y,color,solidfill);
  end;
end;

procedure start_log;
var logfile : text;
begin
  assign (logfile, 'snakepit.log');
  rewrite (logfile);
  writeln (logfile, '--');
  close (logfile);
end;

procedure write_log (turns : integer);
var logfile : text;
    s       : string;
begin
  assign (logfile, 'snakepit.log');
  append (logfile);
  str (turns, s);
  writeln (logfile, s);
  close (logfile);
end;


procedure save_level(num : integer);
var levels,temp : text;
    counter,x,y : integer;
    input,out : string;
begin
  assign(levels,'levels.dat');
  assign(temp,'snakepit.tmp');
  reset(levels);
  rewrite(temp);
  counter:=1;
  while counter<>num do begin
    readln(levels,input);
    writeln(temp,input);
    if input='end' then inc(counter);
  end;
  repeat
    readln(levels,input);
  until input='end';
  for x:=2 to 127 do for y:=1 to 95 do if screen[x,y] = '+' then begin
    str(x,out);
    writeln(temp,out);
    str(y,out);
    writeln(temp,out);
  end;
  writeln(temp,'end');
  repeat
    readln(levels,input);
    writeln(temp,input);
  until input='eof';
  close(levels);
  close(temp);
  erase(levels);
  rename(temp,'levels.dat');
end;


procedure change_level(num : integer);
var x1,x2,x3,x4,y1,y2,y3,y4,s_color,t_color : integer;
    input : char;
    x_mirror, y_mirror : boolean;
begin
  set_up_screen;
  load_level(num);
  clearviewport;
  draw_screen(white);
  s_color := white;
  x_mirror := false;
  y_mirror := false;
  x1 := 64;
  x2 := 65;
  x3 := 64;
  x4 := 65;
  y1 := 48;
  y2 := 48;
  y3 := 49;
  y4 := 49;
  repeat
    do_square(x1,y1,s_color,solidfill);
    if x_mirror then do_square(x2,y2,s_color,solidfill);
    if y_mirror then do_square(x3,y3,s_color,solidfill);
    if (x_mirror) and
       (y_mirror) then do_square(x4,y4,s_color,solidfill);
    input := readkey;
    put_space(x1,y1,s_color);
    if x_mirror then put_space(x2,y2,s_color);
    if y_mirror then put_space(x3,y3,s_color);
    if (x_mirror) and
       (y_mirror) then put_space(x4,y4,s_color);
    if input = ' ' then begin
      reverse(x1,y1,s_color);
      if x_mirror then reverse(x2,y2,s_color);
      if y_mirror then reverse(x3,y3,s_color);
      if (x_mirror) and
         (y_mirror) then reverse(x4,y4,s_color);
    end;
    if input = 'c' then begin
      set_up_screen;
      clearviewport;
      draw_screen(s_color);
    end;
    if ord(input)=0 then begin
      input := readkey;
      case ord(input) of
        59 : if x_mirror = true then x_mirror := false
             else x_mirror := true;
        60 : if y_mirror = true then y_mirror := false
             else y_mirror := true;
        72 : if y1 <> 2 then begin
          dec(y1);
          dec(y2);
          inc(y3);
          inc(y4);
        end;
        80 : if y1 <> 95 then begin
          inc(y1);
          inc(y2);
          dec(y3);
          dec(y4);
        end;
        75 : if x1 <> 2 then begin
          dec(x1);
          inc(x2);
          dec(x3);
          inc(x4);
        end;
        77 : if x1 <> 127 then begin
          inc(x1);
          dec(x2);
          inc(x3);
          dec(x4);
        end;
      end;
      if (not(x_mirror)) and (not(y_mirror)) then t_color := white;
      if (x_mirror) and (not(y_mirror)) then t_color := blue;
      if (not(x_mirror)) and (y_mirror) then t_color := green;
      if (x_mirror) and (y_mirror) then t_color := red;
      if t_color <> s_color then begin
        s_color := t_color;
        clearviewport;
        draw_screen(s_color);
      end;
    end;
  until ord(input) = 27;
  save_level(num);
  clearviewport;
end;


procedure edit_levels;
var levels,temp : text;
    input,out : string;
    counter1,level_num : integer;
    input1 : char;

begin
  assign(levels,'levels.dat');
  reset(levels);
  counter1 := 0;
  level_num := 1;
  repeat
    readln(levels,input);
    if input = 'end' then inc(counter1);
  until input = 'eof';
  close(levels);
  clearviewport;
  SetTextStyle(defaultfont, HorizDir,1);
  repeat
    setcolor(white);
    str(counter1,out);
    outtextxy(0,0,'Levels in LEVELS.DAT : '+out);
    str(level_num,out);
    outtextxy(0,10,'Pick level to edit : '+out);
    input1 := readkey;
    setcolor(black);
    outtextxy(0,10,'Pick level to edit : '+out);
    if ord(input1)=13 then change_level(level_num);
    if ord(input1)=0 then begin
      input1 := readkey;
      case ord(input1) of
        75 : dec(level_num);
        77 : inc(level_num);
      end;
      if level_num > counter1 then level_num := counter1;
      if level_num < 1 then level_num := 1;
    end;
  until ord(input1)=27;
end;

function all_comp : boolean;
var loop : integer;
begin
  all_comp := true;
  for loop := 1 to players do
    if player[loop].computer_player=false then all_comp := false;
end;

procedure disp_scores;
var temp1,temp2,color : integer;
    temp3,temp4,temp5 : string;
    temp6 : char;
begin
  SetTextStyle(sansserifFont, HorizDir,2);
  setcolor(white);
  clearviewport;
  outtextxy(5,5,'Scores. Press any key to continue.');
  temp2 := 55;
  for temp1 := 1 to players do begin
    str(temp1,temp3);
    str(player[temp1].score,temp4);
    str(player[temp1].lives,temp5);
    case temp1 of
      1 : color := red;
      2 : color := blue;
      3 : color := green;
      4 : color := cyan;
      5 : color := magenta;
      6 : color := brown;
      7 : color := lightgray;
      8 : color := yellow;
      9 : color := lightblue;
      10 : color := lightgreen;
      11 : color := lightcyan;
      12 : color := lightred;
    end;
    setcolor(color);
    outtextxy(5,temp2,'Player :');
    outtextxy(105,temp2,temp3);
    setcolor(white);
    outtextxy(205,temp2,'Score :');
    outtextxy(305,temp2,temp4);
    outtextxy(405,temp2,'Lives :');
    outtextxy(505,temp2,temp5);
    inc(temp2,30);
  end;
  str(level,temp3);
  outtextxy(5,temp2,'Level : '+temp3);

  str(blahs,temp3);
  outtextxy(300,temp2,'Moves :'+temp3);

  while keypressed do temp6 := readkey;
  if not ((all_comp) or (demo = play)) then temp6 := readkey
  {else delay(2000)}; {temp6 := readkey;}
  if ord(temp6)=12 then begin
    edit_levels;
    disp_scores;
  end;
  blahs := 0;
end;

procedure start_game;
var temp1,temp2 : integer;
begin
  blahs := 0;
  level_change:=false;
  if max_nums = 0 then total_nums := level
  else total_nums := max_nums;

  nums_to_go[1] := total_nums;

  clear_food_data;
  for temp1 := 2 to 9 do nums_to_go[temp1] := 0;
  for temp1 := 1 to players do begin
    player[temp1].score := 0;
    player[temp1].lives := life_num;
  end;
  disp_scores;
  clearviewport;
  set_up_screen;
  get_level(t_level);
  draw_screen(white);
  for temp1 := 1 to players do begin
    set_up_player(temp1);
    player[temp1].comp_temp1:=0;
    player[temp1].comp_temp2:=1;
    player[temp1].comp_temp3:=0;
    player[temp1].waiting := false;
    player[temp1].dying := false;
    player[temp1].alive := true;
    player[temp1].cur_x := player[temp1].ttempx;
    player[temp1].cur_y := player[temp1].ttempy;
    player[temp1].comp_status := unknown;
    put_player(player[temp1].cur_x,player[temp1].cur_y,temp1,solidfill);
    case player[temp1].cur_dir of
      up : screen[player[temp1].cur_x,player[temp1].cur_y] := 'A';
      down : screen[player[temp1].cur_x,player[temp1].cur_y] := 'B';
      left : screen[player[temp1].cur_x,player[temp1].cur_y] := 'C';
      right : screen[player[temp1].cur_x,player[temp1].cur_y] := 'D';
    end;
  end;
end;

procedure update_curs(num : integer);
begin
  put_player(player[num].cur_x,player[num].cur_y,num,solidfill);
  player[num].temp_x := player[num].cur_x;
  player[num].temp_y := player[num].cur_y;
  case player[num].cur_dir of
    up : begin
      screen[player[num].cur_x,player[num].cur_y] := 'A';
      dec(player[num].temp_y);
    end;
    down : begin
      screen[player[num].cur_x,player[num].cur_y] := 'B';
      inc(player[num].temp_y);
    end;
    left : begin
      screen[player[num].cur_x,player[num].cur_y] := 'C';
      dec(player[num].temp_x);
    end;
    right : begin
      screen[player[num].cur_x,player[num].cur_y] := 'D';
      inc(player[num].temp_x);
    end;
  end;
end;

function crash(num : integer) : boolean;
var temp1 : integer;
begin
  crash := false;
  for temp1 := 1 to players do
    if (temp1 <> num) and
       (player[num].temp_x = player[temp1].temp_x) and
       (player[num].temp_y = player[temp1].temp_y) then crash := true;
  if (screen[player[num].temp_x,player[num].temp_y] = '+') or
     (screen[player[num].temp_x,player[num].temp_y] = '-') or
     (screen[player[num].temp_x,player[num].temp_y] = 'A') or
     (screen[player[num].temp_x,player[num].temp_y] = 'B') or
     (screen[player[num].temp_x,player[num].temp_y] = 'C') or
     (screen[player[num].temp_x,player[num].temp_y] = 'D') then
       crash := true;
end;

function special(x,y : integer) : boolean;
begin
  special := false;
  case screen[x,y] of
    '!' : special := true;
    '@' : special := true;
    '#' : special := true;
    '$' : special := true;
    '%' : special := true;
    '^' : special := true;
    '&' : special := true;
    '*' : special := true;
    '(' : special := true;
    '~' : special := true;
  end;
end;

function still_num(x,y : integer) : boolean;
begin
  still_num := false;
  case screen[x,y] of
    '1' : still_num := true;
    '2' : still_num := true;
    '3' : still_num := true;
    '4' : still_num := true;
    '5' : still_num := true;
    '6' : still_num := true;
    '7' : still_num := true;
    '8' : still_num := true;
    '9' : still_num := true;
    '!' : still_num := true;
    '@' : still_num := true;
    '#' : still_num := true;
    '$' : still_num := true;
    '%' : still_num := true;
    '^' : still_num := true;
    '&' : still_num := true;
    '*' : still_num := true;
    '(' : still_num := true;
    '~' : still_num := true;
  end;
end;

procedure kill_num(sq_x,sq_y : integer);
var temp1, temp2 : integer;
begin
  for temp1 := sq_x to sq_x+3 do begin
    del_food(temp1,sq_y);
    del_food(temp1,sq_y+3);
  end;
  for temp1 := sq_y+1 to sq_y+2 do begin
    del_food(sq_x,temp1);
    del_food(sq_x+3,temp1);
  end;
  for temp1 := sq_x to sq_x+3 do for temp2 := sq_y to sq_y+3 do
  begin
    screen[temp1,temp2] := ' ';
    do_square2(temp1,temp2,black,solidfill);
  end;
end;

procedure eat_num(num : integer);
var tempx, tempy,number,temp,temp1 : integer;
begin
  tempx := player[num].cur_x;
  tempy := player[num].cur_y;
  if screen[tempx,tempy] = '~' then inc(tempy);
  if special(tempx,tempy) then begin
    inc(tempy);
    if (special(tempx,tempy)) or (not(still_num(tempx,tempy))) then begin
      dec(tempy);
      inc(tempx);
    end;
  end;
  val(screen[tempx,tempy],number,temp);
  while not(special(tempx,tempy)) do dec(tempy);
  while screen[tempx,tempy] <> '~' do dec(tempx);
  kill_num(tempx,tempy);
  inc(player[num].to_go,number*4);
{
  inc(player[num].poopies);
}
  inc(player[num].score,number*2);
  player[num].comp_temp3 := 0;
  if number < 9 then inc(nums_to_go[number+1])
  else dec(total_nums);
  if sound_on then sound((number+9)*100);
  beep_stop := 5;
end;

procedure set_attrib(x,y : integer);
begin
  if screen[x+1,y] = '+' then screen[x+1,y] := '-';
  if screen[x-1,y] = '+' then screen[x-1,y] := '-';
  if screen[x,y+1] = '+' then screen[x,y+1] := '-';
  if screen[x,y-1] = '+' then screen[x,y-1] := '-';
end;

procedure update_rest(num : integer);
var tempx, tempy : integer;
begin
  player[num].cur_x := player[num].temp_x;
  player[num].cur_y := player[num].temp_y;
  if screen[player[num].cur_x,player[num].cur_y] = '=' then begin
    inc(player[num].to_go,2);
    inc(player[num].score);
    player[num].comp_temp3:=0;
    {del_food(player[num].cur_x,player[num].cur_y);}
  end
  else if screen[player[num].cur_x,player[num].cur_y] <> ' ' then
     eat_num(num);
  case player[num].cur_dir of
    up    : screen[player[num].cur_x,player[num].cur_y] := 'A';
    down  : screen[player[num].cur_x,player[num].cur_y] := 'B';
    left  : screen[player[num].cur_x,player[num].cur_y] := 'C';
    right : screen[player[num].cur_x,player[num].cur_y] := 'D';
  end;
  if player[num].to_go < 2 then begin
    tempx := player[num].tail_x;
    tempy := player[num].tail_y;
    case screen[tempx,tempy] of
      'A' : dec(player[num].tail_y);
      'B' : inc(player[num].tail_y);
      'C' : dec(player[num].tail_x);
      'D' : inc(player[num].tail_x);
    end;
{
    if (player[num].poopies > 0) and
       (good_spot(tempx,tempy)) then begin
      dec(player[num].poopies);
      screen[tempx,tempy] := '-';
      player[num].trail := false;
      do_square(tempx,tempy,white,solidfill);
    end
    else if (sides(tempx,tempy) = false) and
            (good_spot(tempx,tempy)) and
            (player[num].trail) then begin
      screen[tempx,tempy] := '+';
      player[num].trail := false;
      set_attrib(tempx,tempy);
      do_square(tempx,tempy,white,solidfill);
    end
    else begin
      screen[tempx,tempy] := ' ';
      do_square(tempx,tempy,black,solidfill);
      player[num].trail:=true;
    end;
}
    screen[tempx,tempy] := ' ';
    do_square2(tempx,tempy,black,solidfill);
    player[num].trail:=true;
    inc(player[num].length);
  end
  else dec(player[num].to_go,2);
  if player[num].alive then
    do_square(player[num].cur_x,player[num].cur_y,white,solidfill);
end;

procedure kill(num : integer);
begin
  if sound_on then woopie;
  player[num].alive := false;
  player[num].dying := true;
  dec(player[num].lives);
  player[num].death_delay := 1;
end;

procedure re_vamp_player(num : integer);
begin
  set_up_player(num);
  player[num].dying := false;
  if player[num].lives > 0 then player[num].waiting := true
  else player[num].waiting := false;
  player[num].cur_x := 1;
  player[num].cur_y := 1;
end;

procedure die(num : integer);
var tempx, tempy : integer;
begin
  if player[num].dying then begin
    if player[num].death_delay = 0 then begin
      tempx := player[num].tail_x;
      tempy := player[num].tail_y;
      case screen[tempx,tempy] of
        'A' : dec(player[num].tail_y);
        'B' : inc(player[num].tail_y);
        'C' : dec(player[num].tail_x);
        'D' : inc(player[num].tail_x);
      end;
{
      if (sides(tempx,tempy) = false) and
         (good_spot(tempx,tempy)) and
         (player[num].trail) then begin
        screen[tempx,tempy] := '+';
        do_square(tempx,tempy,white,solidfill);
        set_attrib(tempx,tempy);
        player[num].trail := false;
      end
      else begin
        screen[tempx,tempy] := '=';
        -- add_food(tempx,tempy); --
        do_square(tempx,tempy,white,closedotfill);
        player[num].trail := true;
      end;
}
      screen[tempx,tempy] := '=';
      {add_food(tempx,tempy);}
      do_square2(tempx,tempy,white,closedotfill);
      player[num].trail := true;

      dec(player[num].length);
      player[num].death_delay := 1;
      if (player[num].cur_x = tempx) and
         (player[num].cur_y = tempy) then begin
        re_vamp_player(num);
      end;
    end
    else dec(player[num].death_delay);
  end;
end;

procedure start_up_player(num : integer);
begin
  if (screen[player[num].ttempx,player[num].ttempy] = ' ') or
     (screen[player[num].ttempx,player[num].ttempy] = '=') then begin
    player[num].waiting := false;
    player[num].dying := false;
    player[num].alive := true;
    player[num].comp_temp3 := 0;
    player[num].cur_x := player[num].ttempx;
    player[num].cur_y := player[num].ttempy;
    if screen[player[num].cur_x,player[num].cur_y]='=' then
      {del_food(player[num].cur_x,player[num].cur_y)};
    case player[num].cur_dir of
      up : screen[player[num].cur_x,player[num].cur_y] := 'A';
      down : screen[player[num].cur_x,player[num].cur_y] := 'B';
      left : screen[player[num].cur_x,player[num].cur_y] := 'C';
      right : screen[player[num].cur_x,player[num].cur_y] := 'D';
    end;
    put_player(player[num].cur_x,player[num].cur_y,num,solidfill);
  end;
end;

{-------------------------------------------------------------------------}

function okay_to_move(num : integer; var u,d,l,r : boolean) : boolean;
begin
  okay_to_move := false;
  u := false;
  d := false;
  l := false;
  r := false;
  player[num].temp_x := player[num].cur_x+1;
  player[num].temp_y := player[num].cur_y;
  if not(crash(num)) then begin
    okay_to_move := true;
    r := true;
  end;
  player[num].temp_x := player[num].cur_x-1;
  player[num].temp_y := player[num].cur_y;
  if not(crash(num)) then begin
    okay_to_move := true;
    l := true;
  end;
  player[num].temp_x := player[num].cur_x;
  player[num].temp_y := player[num].cur_y+1;
  if not(crash(num)) then begin
    okay_to_move := true;
    d := true;
  end;
  player[num].temp_x := player[num].cur_x;
  player[num].temp_y := player[num].cur_y-1;
  if not(crash(num)) then begin
    okay_to_move := true;
    u := true;
  end;
end;

function crash2(x,y : integer) : boolean;
var temp1 : integer;
begin
  crash2 := false;
  for temp1 := 1 to players do
    if (x = player[temp1].temp_x) and
       (y = player[temp1].temp_y) then crash2 := true;
  if (screen[x,y] = '+') or
     (screen[x,y] = '-') or
     (screen[x,y] = 'A') or
     (screen[x,y] = 'B') or
     (screen[x,y] = 'C') or
     (screen[x,y] = 'D') then
       crash2 := true;
end;

function check_end(b_x,b_y,x,y:integer; var next_dir : dirs) : integer;
var total_dirs : integer;
    temp : char;
begin
  temp := screen[b_x,b_y];
  screen[b_x,b_y]:='A';
  total_dirs:=0;
  if not(crash2(x,y-1)) then begin
    next_dir := up;
    inc(total_dirs);
  end;
  if not(crash2(x,y+1)) then begin
    next_dir := down;
    inc(total_dirs);
  end;
  if not(crash2(x-1,y)) then begin
    next_dir := left;
    inc(total_dirs);
  end;
  if not(crash2(x+1,y)) then begin
    next_dir := right;
    inc(total_dirs);
  end;
  screen[b_x,b_y] := temp;
  if total_dirs = 0 then check_end := 0
    else if total_dirs = 1 then check_end := 1
      else check_end := 2;
end;

function dead_end(x,y,b_x,b_y : integer) : boolean;
var end_it : boolean;
    next_dir : dirs;
    status : integer;
begin
  end_it := false;
  repeat
    status := check_end(b_x,b_y,x,y,next_dir);
    if status = 0 then begin
      end_it := true;
      dead_end := true;
    end;
    if status = 2 then begin
      end_it := true;
      dead_end := false;
    end;
    if status = 1 then begin
      b_x := x;
      b_y := y;
      case next_dir of
        up    : dec(y);
        down  : inc(y);
        left  : dec(x);
        right : inc(x);
      end;
    end;
  until end_it;
end;

procedure advanced_dir_checking(num : integer; var u,d,l,r : boolean);
var num_dirs : integer;
    u_good, d_good, l_good, r_good : boolean;
begin
  num_dirs := 0;
  if u then inc(num_dirs);
  if d then inc(num_dirs);
  if l then inc(num_dirs);
  if r then inc(num_dirs);
  if num_dirs = 1 then exit;
  u_good := u;
  d_good := d;
  l_good := l;
  r_good := r;
  if u_good then if dead_end(player[num].cur_x,player[num].cur_y-1,
                             player[num].cur_x,player[num].cur_y) then
    u_good := false;
  if d_good then if dead_end(player[num].cur_x,player[num].cur_y+1,
                             player[num].cur_x,player[num].cur_y) then
    d_good := false;
  if l_good then if dead_end(player[num].cur_x-1,player[num].cur_y,
                             player[num].cur_x,player[num].cur_Y) then
    l_good := false;
  if r_good then if dead_end(player[num].cur_x+1,player[num].cur_y,
                             player[num].cur_x,player[num].cur_Y) then
    r_good := false;
  num_dirs := 0;
  if u_good then inc(num_dirs);
  if d_good then inc(num_dirs);
  if l_good then inc(num_dirs);
  if r_good then inc(num_dirs);
  if num_dirs>0 then begin
    u := u_good;
    d := d_good;
    l := l_good;
    r := r_good;
  end;
  if num_dirs = 1 then exit;
  u_good := false;
  d_good := false;
  l_good := false;
  r_good := false;
  if u then if not(crash2(player[num].cur_x,player[num].cur_y-2)) then
    u_good := true;
  if d then if not(crash2(player[num].cur_x,player[num].cur_y+2)) then
    d_good := true;
  if l then if not(crash2(player[num].cur_x-2,player[num].cur_y)) then
    l_good := true;
  if r then if not(crash2(player[num].cur_x+2,player[num].cur_y)) then
    r_good := true;
  num_dirs := 0;
  if u_good then inc(num_dirs);
  if d_good then inc(num_dirs);
  if l_good then inc(num_dirs);
  if r_good then inc(num_dirs);
  if num_dirs>0 then begin
    u := u_good;
    d := d_good;
    l := l_good;
    r := r_good;
  end;
end;

procedure comp_move(num:integer);
var u,d,l,r : boolean;
    temp : integer;
begin
  inc(player[num].comp_temp3);
  if player[num].comp_temp3 > 1000 then exit;
  if okay_to_move(num,u,d,l,r) then begin
    if (player[num].food_x = 0) or
       (player[num].comp_temp1 = 0)
      then find_closest_food(num);
    if player[num].food_x = 0 then exit;
    player[num].cur_dir := none;
    advanced_dir_checking(num,u,d,l,r);
    if player[num].comp_temp1 = 0 then begin
      if player[num].comp_temp2 = 2 then
        player[num].comp_temp2 := 1
      else player[num].comp_temp2 := 2;
      player[num].comp_temp1 := random(100)+1;
    end;
    dec(player[num].comp_temp1);
    if player[num].comp_temp2 = 1 then begin

      if (player[num].food_x < player[num].cur_x) and (l) then
        player[num].cur_dir := left;

      if (player[num].food_x > player[num].cur_x) and (r) then
        player[num].cur_dir := right;

      if (player[num].food_y < player[num].cur_y) and (u) then
        player[num].cur_dir := up;

    if (player[num].food_y > player[num].cur_y) and (d) then
      player[num].cur_dir := down;

    end

    else begin

      if (player[num].food_y < player[num].cur_y) and (u) then
        player[num].cur_dir := up;

    if (player[num].food_y > player[num].cur_y) and (d) then
      player[num].cur_dir := down;

      if (player[num].food_x < player[num].cur_x) and (l) then
        player[num].cur_dir := left;

      if (player[num].food_x > player[num].cur_x) and (r) then
        player[num].cur_dir := right;

    end;

    if player[num].cur_dir = none then
      if player[num].comp_temp2 = 1 then begin
        if u then player[num].cur_dir := up;
        if d then player[num].cur_dir := down;
        if l then player[num].cur_dir := left;
        if r then player[num].cur_dir := right;
      end
      else begin
        if l then player[num].cur_dir := left;
        if r then player[num].cur_dir := right;
        if u then player[num].cur_dir := up;
        if d then player[num].cur_dir := down;
      end;

  end;
end;

function check_alive : boolean;
var temp1 : integer;
begin
  check_alive := false;
  level_change := false;
  for temp1 := 1 to players do begin
    if player[temp1].alive = true then check_alive := true;
  end;
  if total_nums = 0 then level_change := true;
  if level_change = true then begin
    inc(level);
    t_level := level;
    check_alive := false;
  end;
end;

function lives_left : boolean;
var temp1 : integer;
begin
  lives_left := false;
  for temp1 := 1 to players do
    if player[temp1].lives > 0 then lives_left := true;
end;

procedure start_over(var game_over : boolean);
var temp1 : integer;
begin
  if lives_left then begin
    if level_change then begin
      if max_nums = 0 then total_nums := level
      else total_nums := max_nums;
      level_change := false;
    end;
    if sound_on then alarm;
    delay(1000);
    disp_scores;
    nums_to_go[1] := total_nums;
    clear_food_data;
    for temp1 := 2 to 9 do nums_to_go[temp1] := 0;
    clearviewport;
    set_up_screen;
    get_level(t_level);
    draw_screen(white);
    for temp1 := 1 to players do begin
      re_vamp_player(temp1);
      if player[temp1].lives > 0 then start_up_player(temp1);
    end;
  end
  else game_over := true;
end;

function clear(x,y : integer) : boolean;
var temp1, temp2 : integer;
    temp : boolean;
begin
  temp := true;
  if x < 3 then temp := false;
  if y < 3 then temp := false;
  if temp then for temp1 := x to x+3 do for temp2 := y to y+3 do
    if (not(screen[temp1,temp2] = ' ')) and
       (not(screen[temp1,temp2] = '=')) then temp := false;
  clear := temp;
end;

procedure check_nums;
var temp1,temp2,tempx,tempy : integer;
    got_it : boolean;
begin
  for temp1 := 1 to 9 do if nums_to_go[temp1] > 0 then repeat
    temp2 := 0;
    got_it := false;
    repeat
      inc(temp2);
      if temp2 = 5000 then exit;
      tempx := random2(123) + 1;
      tempy := random2(91) + 1;
      if clear(tempx,tempy) then got_it := true;
    until got_it;
    draw_number(tempx,tempy,temp1);
    dec(nums_to_go[temp1]);
  until nums_to_go[temp1] = 0;
end;

procedure play_demo (num : integer);
var temp : integer;
begin
  read(demo_file,temp);
  case temp of
    1 : player[num].cur_dir := up;
    2 : player[num].cur_dir := down;
    3 : player[num].cur_dir := left;
    4 : player[num].cur_dir := right;
  end;
end;

procedure check_end2(var game_over : boolean);
var temp : integer;
begin
  read(demo_file,temp);
  if temp = 666 then game_over := true;
end;

procedure main;
var temp1,temp : integer;
    time,t_delay : longint;
    h,m,s,hun : array [1..3] of word;
    game_over : boolean;
begin
  game_over := false;
  repeat
    inc(blahs);
    if check_alive = false then start_over(game_over);
    gettime(h[1],m[1],s[1],hun[1]);
    check_nums;

    for temp1 := 1 to 12 do begin
      player[temp1].temp_x := 1;
      player[temp1].temp_y := 1;
    end;

    for temp1 := 1 to players do begin
      if player[temp1].alive then begin
        if demo = play then begin
          play_demo(temp1);
          check_esc(game_over);
        end
        else begin
          get_keys(game_over);
          if player[temp1].computer_player then comp_move(temp1)
          else human_move(temp1);
          case player[temp1].cur_dir of
            up    : temp := 1;
            down  : temp := 2;
            left  : temp := 3;
            right : temp := 4;
          end;
          if demo = record_demo then write(demo_file,temp);
        end;
        update_curs(temp1);
      end;
    end;
    if demo = play then check_end2(game_over);
    if game_over = true then temp := 666
    else temp := 0;
    if demo = record_demo then write(demo_file,temp);

    for temp1 := 1 to players do begin
      if player[temp1].alive then
        if crash(temp1) = false then update_rest(temp1)
        else kill(temp1)
      else begin
        if player[temp1].dying then die(temp1);
      end;
      if player[temp1].waiting then start_up_player(temp1);
    end;
    gettime(h[2],m[2],s[2],hun[2]);
    hun[3] := hun[2]-hun[1];
    if hun[3] < 0 then begin
      hun[3] := hun[3]+100;
      s[2] := s[2]-1
    end;
    s[3] := s[2]-s[1];
    if s[3] < 0 then begin
      s[3] := s[3]+60;
      m[2] := m[2]-1;
    end;
    m[3] := m[2]-m[1];
    if m[3] < 0 then begin
      m[3] := m[3]+60;
      h[2] := h[2]-1;
    end;
    h[3] := h[2]-h[1];
    if h[3] < 0 then h[3] := h[3]+24;
    time := s[3]*1000+hun[3]*10;
    t_delay := d_length-time;
    if t_delay > 0 then delay(t_delay);
    dec(beep_stop);
    if beep_stop = 0 then nosound;
  until game_over;
end;

var temp1, temp2,temp3,color,orig_mode,tmp : integer;
    input : char;
    tstring : string;
    end_loop, spec: boolean;

begin
  demo := normal;
  if paramcount > 0 then begin
    tstring := paramstr(1);
    if tstring = '-record' then begin
      demo := record_demo;
      if paramcount = 0 then begin
        writeln('You need to specify a file to record a demo.');
        halt;
      end;
      assign(demo_file,paramstr(2)+'.nib');
      rewrite(demo_file);
    end;
    if tstring = '-play' then begin
      demo := play;
      if paramcount = 0 then begin
        writeln('You need to specify a file to play a demo.');
        halt;
      end;
      assign(demo_file,paramstr(2)+'.nib');
      reset(demo_file);
    end;
  end;


  orig_mode := lastmode;
  new(food_data_x);
  new(food_data_y);
  randomize;
{
  Assign(FontF, 'GOTH.CHR');
  Reset(FontF, 1);
  GetMem(FontP, FileSize(FontF));
  BlockRead(FontF, FontP^,
            FileSize(FontF));
  if RegisterBGIfont(FontP) < 0 then
  begin
    WriteLn('Error registering font: ',
            GraphErrorMsg(GraphResult));
    Halt(1);
    dispose(food_data_x);
    dispose(food_data_y);
  end;
  close(FontF);
}
  GraphDriver := Detect;
  InitGraph(GraphDriver, GraphMode, '');
  set_up_screen;
  if demo = play then begin
    read(demo_file,players);
    for temp1 := 1 to players do begin
      read(demo_file,temp2);
      case temp2 of
        0 : player[temp1].computer_player := true;
        1 : player[temp1].computer_player := false;
      end;
    end;
    read(demo_file,life_num);
    read(demo_file,max_nums);
    read(demo_file,level);
    t_level := level;
    sound_on := false;
    d_length := 50;
  end

  else begin
    draw_screen(white);
    SetTextStyle(sansserifFont, HorizDir,5);
    setcolor(yellow);
    outtextxy(10,0,'Welcome to');
    SetTextStyle(GothicFont, HorizDir,10);
    for color := 1 to 15 do begin
      setcolor(color);
      outtextxy(10+color,20+color,'Snake Pit');
    end;
    setcolor(white);
    SetTextStyle(sansserifFont, horizDir,2);
    outtextxy(10,160,'Copyright (1994) Jeff Weston.');

    setcolor(red);
    SetTextStyle(sansserifFont, HorizDir,2);
    outtextxy(10,180,'Enter the number of players (1-12)');
    setcolor(green);
    outtextxy(10,200,'Use the left and right arrow keys.');

    players := 1;
    setcolor(white);
    str(players,tstring);
    outtextxy(385,180,tstring);
    end_loop := false;

    repeat
      input := readkey;
      if ord(input) = 13 then end_loop := true;
      if ord(input) = 0 then begin
        input := readkey;
        case ord(input) of
          77 : begin
            inc(players);
            if players > 12 then players := 12;
          end;
          75 : begin
            dec(players);
            if players < 1 then players := 1;
          end;
        end;
      end;
      setcolor(black);
      outtextxy(385,180,tstring);
      setcolor(white);
      str(players,tstring);
      outtextxy(385,180,tstring);
    until end_loop;

    if demo = record_demo then write(demo_file,players);

    temp1 := 200;


    for temp2 := 1 to players do begin
      setcolor(yellow);
      temp1 := temp1 + 20;
      str(temp2,tstring);
      outtextxy(10,temp1,'Is player #'+tstring+' a computer?');
      setcolor(blue);
      if yn then begin
        outtextxy(280,temp1,'Yes.');
        player[temp2].computer_player := true;
        tmp := 0;
        if demo = record_demo then write(demo_file,tmp);
      end
      else begin
        outtextxy(280,temp1,'No.');
        player[temp2].computer_player := false;
        tmp := 1;
        if demo = record_demo then write(demo_file,tmp);
      end;
    end;


    for temp1 := 1 to 12 do for temp2 := 1 to 4 do begin
      player[temp1].key_sp[temp2] := false;
      player[temp1].keys[temp2] := chr(27);
    end;
    for temp1 := 1 to players do begin
      if player[temp1].computer_player = false then
      repeat
        clearviewport;
        draw_screen(white);
        setcolor(blue);
        str(temp1,tstring);
        outtextxy(10,10,'Pick Keys for player #'+tstring);
        setcolor(yellow);
        outtextxy(10,30,'Up    :');
        outtextxy(10,50,'Down  :');
        outtextxy(10,70,'Left  :');
        outtextxy(10,90,'Right :');
        temp3 := 10;
        setcolor(red);
        for temp2 := 1 to 4 do begin
          player[temp1].key_sp[temp2] := false;
          player[temp1].keys[temp2] := chr(27);
        end;
        for temp2 := 1 to 4 do begin
          temp3 := temp3 + 20;

          repeat
            input := upcase(readkey);
            if ord(input) = 0 then begin
              spec := true;
              input := readkey;
            end
            else spec := false;
            if not(check_keys(input,spec)) then begin
              setcolor(white);
              outtextxy(100,temp3,'Already Used');
              delay(500);
              setcolor(black);
              outtextxy(100,temp3,'Already Used');
              setcolor(red);
              end_loop := false;
            end
            else end_loop := true;
          until end_loop;
          if spec = true then begin
            player[temp1].key_sp[temp2] := true;
            str(ord(input),tstring);
            case ord(input) of
              72 : tstring := 'Up Arrow';
              80 : tstring := 'Down Arrow';
              75 : tstring := 'Left Arrow';
              77 : tstring := 'Right Arrow';
            else
              tstring := 'Special : '+tstring;
            end;
            outtextxy(100,temp3,tstring);
          end
          else begin
            player[temp1].key_sp[temp2] := false;
            outtextxy(100,temp3,input);
          end;
          player[temp1].keys[temp2] := input;
        end;
        setcolor(white);
        outtextxy(10,150,'Are these acceptable?');
      until yn;
    end;

    d_length := 50;
    clearviewport;
    draw_screen(white);
    setcolor(red);
    outtextxy(10,10,'Pick the delay.');
    setcolor(yellow);
    outtextxy(10,30,'Left and right go by 1');
    outtextxy(10,50,'Up and down go by 10');
    setcolor(white);
    str(d_length,tstring);
    outtextxy(160,10,tstring);
    end_loop := false;

    repeat
      input := readkey;
      if ord(input) = 13 then end_loop := true;
      if ord(input) = 0 then begin
        input := readkey;
        case ord(input) of
          72 : d_length := d_length + 10;
          80 : d_length := d_length - 10;
          75 : dec(d_length);
          77 : inc(d_length);
        end;
        if d_length < 1 then d_length := 1;
        setcolor(black);
        outtextxy(160,10,tstring);
        setcolor(white);
        str(d_length,tstring);
        outtextxy(160,10,tstring);
      end;
    until end_loop;


    life_num := 10;
    clearviewport;
    draw_screen(white);
    setcolor(red);
    outtextxy(10,10,'Pick the number of lives.');
    setcolor(yellow);
    outtextxy(10,30,'Left and right go by 1');
    outtextxy(10,50,'Up and down go by 10');
    setcolor(white);
    str(life_num,tstring);
    outtextxy(260,10,tstring);
    end_loop := false;

    repeat
      input := readkey;
      if ord(input) = 13 then end_loop := true;
      if ord(input) = 0 then begin
        input := readkey;
        case ord(input) of
          72 : life_num := life_num + 10;
          80 : life_num := life_num - 10;
          75 : dec(life_num);
          77 : inc(life_num);
        end;
        if life_num < 1 then life_num := 1;
        setcolor(black);
        outtextxy(260,10,tstring);
        setcolor(white);
        str(life_num,tstring);
        outtextxy(260,10,tstring);
      end;
    until end_loop;

    if demo = record_demo then write(demo_file,life_num);

    max_nums := 0;
    clearviewport;
    draw_screen(white);
    setcolor(red);
    outtextxy(10,10,'Pick the nums needed to pass a level. (0 = progressive)');
    setcolor(yellow);
    outtextxy(10,30,'Left and right go by 1');
    outtextxy(10,50,'Up and down go by 10');
    setcolor(white);
    str(max_nums,tstring);
    outtextxy(580,10,tstring);
    end_loop := false;

    repeat
      input := readkey;
      if ord(input) = 13 then end_loop := true;
      if ord(input) = 0 then begin
        input := readkey;
        case ord(input) of
          72 : max_nums := max_nums + 10;
          80 : max_nums := max_nums - 10;
          75 : dec(max_nums);
          77 : inc(max_nums);
        end;
        if max_nums < 0 then max_nums := 0;
        setcolor(black);
        outtextxy(580,10,tstring);
        setcolor(white);
        str(max_nums,tstring);
        outtextxy(580,10,tstring);
      end;
    until end_loop;

    if demo = record_demo then write(demo_file,max_nums);

    level := 1;
    clearviewport;
    draw_screen(white);
    setcolor(red);
    outtextxy(10,10,'Pick the starting level.');
    setcolor(yellow);
    outtextxy(10,30,'Left and right go by 1');
    outtextxy(10,50,'Up and down go by 10');
    setcolor(white);
    str(level,tstring);
    outtextxy(300,10,tstring);
    end_loop := false;

    repeat
      input := readkey;
      if ord(input) = 13 then end_loop := true;
      if ord(input) = 0 then begin
        input := readkey;
        case ord(input) of
          72 : level := level + 10;
          80 : level := level - 10;
          75 : dec(level);
          77 : inc(level);
        end;
        if level < 1 then level := 1;
        setcolor(black);
        outtextxy(300,10,tstring);
        setcolor(white);
        str(level,tstring);
        outtextxy(300,10,tstring);
      end;
    until end_loop;

    t_level := level;
    if demo = record_demo then write(demo_file,level);

    clearviewport;
    draw_screen(white);
    setcolor(yellow);
    outtextxy(10,5,'Do you want sound?');

    if yn then sound_on := true
    else sound_on := false;

  end;

  start_game;
  main;
  if sound_on then begin
    beep;
    boop;
    bell;
    woopie;
    buzzsaw;
    alarm;
  end;
  delay(1000);
  disp_scores;
  closegraph;
  dispose(food_data_x);
  dispose(food_data_y);
  textmode(orig_mode);
end.
